//
// Basic wrapper for OpenGL VBO extension
//
// Author: Alex V. Boreskoff, <steps3d@narod.ru>
//

#ifndef	__VERTEX_BUFFER_CLASS__
#define	__VERTEX_BUFFER_CLASS__

#include	"libExt.h"

class	VertexBuffer
{
	GLuint	id;
	GLenum	target;
	bool	ok;
	
public:
	VertexBuffer  ();
	~VertexBuffer ();

	GLenum 	getId () const
	{
		return id;
	}
	
	void	bind   ( GLenum theTarget );
	void	unbind ();
	
	void	setData    ( unsigned size, const void * ptr, GLenum usage );
	void	setSubData ( unsigned offs, unsigned size, const void * ptr );
	void	getSubData ( unsigned offs, unsigned size, void * ptr );

	void  * map   ( GLenum access );
	bool	unmap ();
	
	static	bool	isSupported ();
};

#endif
